Package com.xebialabs.deployit.plugin.api.reflect

## Class BaseDescriptorRegistry

- java.lang.Object
- - com.xebialabs.deployit.plugin.api.reflect.BaseDescriptorRegistry

- All Implemented Interfaces:
    `IDescriptorRegistry`, `java.lang.AutoCloseable`

      public abstract class BaseDescriptorRegistry
      extends java.lang.Object
      implements IDescriptorRegistry

- - ### Field Summary

    - ### Fields inherited from interface com.xebialabs.deployit.plugin.api.reflect.IDescriptorRegistry

      `DEFAULT_PRECEDENCE, HIGHEST_PRECEDENCE, LOWEST_PRECEDENCE`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `BaseDescriptorRegistry​(DescriptorRegistryId id)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.util.List<DescriptorRegistryHook>` | `getHooks()` |
    `DescriptorRegistryId` | `getId()` |
    `Type` | `lookupType​(java.lang.Class<?> ciClass)` | Searches in the registry for a CI type by CI class.
    `Type` | `lookupType​(java.lang.String typeName)` | Searches in the registry for a CI type by CI prefixed type name.
    `Type` | `lookupType​(java.lang.String prefix, java.lang.String simpleName)` | Searches in the registry for a CI type by CI prefix and simple name.
    `void` | `registerHook​(DescriptorRegistryHook hook)` |
    `void` | `verifyTypes()` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.xebialabs.deployit.plugin.api.reflect.IDescriptorRegistry

      `close, exists, getDescriptor, getDescriptors, getOrder, getSubtypes, isDefault, isLocal, register, registerSubtype`

- - ### Constructor Detail

    - #### BaseDescriptorRegistry

          protected BaseDescriptorRegistry​(DescriptorRegistryId id)

  - ### Method Detail

    - #### lookupType

          public Type lookupType​(java.lang.Class<?> ciClass)

      Searches in the registry for a CI type by CI class.
      Specified by:
        `lookupType` in interface `IDescriptorRegistry`
      Parameters:
        `ciClass` - A class instance of a CI.
      Returns:
        The type for the given CI class.

    - #### lookupType

          public Type lookupType​(java.lang.String typeName)

      Searches in the registry for a CI type by CI prefixed type name.
      Specified by:
        `lookupType` in interface `IDescriptorRegistry`
      Parameters:
        `typeName` - The prefixed type name of a CI.
      Returns:
        The type of the CI.

    - #### lookupType

          public Type lookupType​(java.lang.String prefix,
                                 java.lang.String simpleName)

      Searches in the registry for a CI type by CI prefix and simple name.
      Specified by:
        `lookupType` in interface `IDescriptorRegistry`
      Parameters:
        `prefix` - The prefix of a CI.
        `simpleName` - The simple name of a CI.
      Returns:
        The type of the CI.

    - #### getId

          public DescriptorRegistryId getId()

      Specified by:
        `getId` in interface `IDescriptorRegistry`

    - #### verifyTypes

          public void verifyTypes()

      Specified by:
        `verifyTypes` in interface `IDescriptorRegistry`

    - #### registerHook

          public void registerHook​(DescriptorRegistryHook hook)

      Specified by:
        `registerHook` in interface `IDescriptorRegistry`

    - #### getHooks

          public java.util.List<DescriptorRegistryHook> getHooks()

      Specified by:
        `getHooks` in interface `IDescriptorRegistry`